Files
lbmk/lbmk
T
Leah Rowe c6fd4d2ad3 lbmk: run ./build dependencies *before* root check
After that, do not allow anything to run if the user is
root. This logic flow is more robust, and reduces the
chance of bugs in the future.

We must not permit the user to run lbmk as root.

Running it as root *is* possible, by just removing
the check, and wily enough users will do that, but
this behaviour in lbmk is good practise because it
prevents accidentally running as root. If the user
went into root just for installing dependencies, they
might accidentally forget to switch back. This is a
safeguard against such folly.

Signed-off-by: Leah Rowe <leah@libreboot.org>
2023-08-28 15:28:19 +01:00

128 lines
3.4 KiB
Bash
Executable File

#!/usr/bin/env sh
# generic script for calling other scripts in lbmk
#
# Copyright (C) 2014,2015,2020,2021,2023 Leah Rowe <info@minifree.org>
# Copyright (C) 2015 Patrick "P. J." McDermott <pj@pehjota.net>
# Copyright (C) 2015, 2016 Klemens Nanni <contact@autoboot.org>
# Copyright (C) 2022, Caleb La Grange <thonkpeasant@protonmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
[ "x${DEBUG+set}" = 'xset' ] && set -v
set -u -e
. "include/err.sh"
projectname="$(cat projectname)"
buildpath=""
mode=""
option=""
main()
{
id -u 1>/dev/null 2>/dev/null || \
err "cannot ascertain user id"
[ "${0##*/}" = "lbmk" ] && err "Don't run this script directly."
[ $# -lt 1 ] && err "Too few arguments. Try: ${0} help"
mode="${1}"
if [ "${mode}" = "dependencies" ]; then
if [ $# -lt 2 ]; then
printf "You must specify a distro, namely:\n" 1>&2
printf "Look at files under resources/dependencies/\n" \
1>&2
printf "Example: ./build dependencies debian\n" 1>&2
err "target not specified"
fi
install_dependencies $@ || err "Could not install dependencies"
exit 0
fi
if [ "$(id -u)" = "0" ]; then
err "running this command as root is not permitted"
fi
buildpath="./script/${0##*/}"
[ "${mode}" = "help" ] && usage ${0} && exit 0
[ "${mode}" = "list" ] && ./build command options "${buildpath}" && \
exit 0
[ $# -lt 2 ] && usage ${0} && exit 1
./checkgit || err "Please read: https://libreboot.org/docs/build/"
option="${2}"
shift 2
./script/misc/versioncheck || \
err "Cannot check lbmk version"
case "${option}" in
list)
./build command options "${buildpath}/${mode}" ;;
all)
for option in $(./build command options "${buildpath}/${mode}")
do
"${buildpath}/${mode}/${option}" $@ || \
err "script fail: ${buildpath}/${mode}/${option} $@"
done
;;
*)
if [ ! -d "${buildpath}/${mode}" ]; then
usage $0
err "Invalid mode '${mode}'. Run: ${0} help"
elif [ ! -f "${buildpath}/${mode}/${option}" ]; then
usage $0
printf "Invalid option for '%s'." ${mode}
err "Run: ${0} ${mode} list'."
fi
"${buildpath}/${mode}/${option}" $@ || err "lbmk error"
esac
}
install_dependencies()
{
[ -f "resources/dependencies/${2}" ] || err "Unsupported target"
aur_notice=""
. "resources/dependencies/${2}"
${pkg_add} ${pkglist} || \
err "install_dependencies: Error installing dependencies"
[ "${aur_notice}" = "" ] || \
printf "You must install AUR packages: %s\n" "${aur_notice}" 1>&2
}
usage()
{
progname=${0}
cat <<- EOF
USAGE: ${progname} <MODE> <OPTION>
possible values for 'mode':
$(./build command options "${buildpath}/${mode}")
Example: ${progname} module all
Example: ${progname} module flashrom [static]
Example: ${progname} roms withgrub
Example: ${progname} clean all
Refer to ${projectname} documentation for more info.
EOF
}
main $@